﻿using Microsoft.AspNetCore.Http;
using System.Threading.Tasks;

namespace TestProject
{
    /// <summary>
    /// 종단 미들웨어
    /// </summary>
    public class TerminalMiddleware
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 다음 미들웨어
        /// </summary>
        private RequestDelegate next;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - TerminalMiddleware(next)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="next">다음 미들웨어</param>
        public TerminalMiddleware(RequestDelegate next)
        {
            this.next = next;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 호출하기 - Invoke(context)

        /// <summary>
        /// 호출하기
        /// </summary>
        /// <param name="context">HTTP 컨텍스트</param>
        /// <returns>태스크</returns>
        public async Task Invoke(HttpContext context)
        {
            Endpoint endpoint = context.GetEndpoint();

            if(endpoint == null)
            {
                context.Response.StatusCode = StatusCodes.Status401Unauthorized;
            }
            else
            {
                await next.Invoke(context);
            }
        }

        #endregion
    }
}